<?php
/**
* Plugin Name: Disable Comments by click5
* Plugin URI: https://www.click5interactive.com/disable-comments-wordpress-plugin/
* Description: Disable comments on your website and protect yourself from spammers.
* Version: 1.0.0
* Author: click5 Interactive
* Author URI: https://www.click5interactive.com/?utm_source=comments-plugin&utm_medium=plugin-list&utm_campaign=wp-plugins
* Text Domain: disable-comments-by-click5
* Domain Path: /languages
**/

define('click5_disable_comments_VERSION', '1.0.0');
define('click5_disable_comments_DEV_MODE', true);
define( 'CLICK5_DISABLE_COMMENTS_PLUGIN_PATH', plugin_dir_path( __FILE__ ) );

//get post type
function click5_disable_comments_get_post_types($at_least = 1) {
  $post_types = get_post_types(array('public' => true), 'names');
  $result_post_types = array();

  foreach($post_types as $post_type) {

    if (post_type_supports($post_type, 'comments')) {
      $result_post_types[] = $post_type;
    }
  
  }

  return $result_post_types;
}

add_action( 'plugins_loaded', 'init_disable_comments_by_click5' );
 
function init_disable_comments_by_click5() {
  if(get_option("click5_disable_comments_display_rpc")=="1")
  {
    add_filter('xmlrpc_methods',  'click5_disable_rpc_comments', 20, 2);
  }
  if(get_option("click5_disable_comments_display_api")=="1")
  {
    add_filter('rest_pre_insert_comment',  'click5_disable_api_comments', 20, 2);
  }
}

function click5_disable_rpc_comments($methods)
{
		unset($methods['wp.newComment']);
		return $methods;
}

function click5_disable_api_comments($prepared_comment, $request)
{
		return;
}


//disable comments functions
add_filter( 'comments_array', 'click5_disable_comments_filter_existing_comments', 20, 2 );
function click5_disable_comments_filter_existing_comments($comments, $post_id) {
  $post = get_post( $post_id );
  $type = $post->post_type;
  $mystring = $post->guid;
  $findme   = 'page_id';
  $res = strpos($mystring, $findme);
  $option_name = 'click5_disable_comments_display_'.$type;

      if(get_option('click5_disable_comments_display_globally')=="1"){
        add_filter('comments_template', 'click5_disable_comments_empty_comments_template', 20);
        return array() ;
      }
      else if(get_option($option_name)=="1"){
        add_filter('comments_template', 'click5_disable_comments_empty_comments_template', 20);
        return array() ;
      }
      else{
        return $comments;
      }

      return $comments;
}

add_filter( 'wp_disable_comments_by_click5_enabled', '__return_false' );


function click5_disable_comments_empty_comments_template()
	{
		return dirname(__FILE__) . '/comments.php';
	}

//end of disable comments functions

function click5_disable_comments_auto_update ( $update, $item ) {
	$plugins = array ( 'disable-comments-by-click5' );
	if ( in_array( $item->slug, $plugins ) ) {
		// update plugin
		return true; 
	} else {
		// use default settings
		return $update; 
	}
}
add_filter( 'auto_update_plugin', 'click5_disable_comments_auto_update', 10, 2 );

add_action('admin_menu', 'click5_disable_comments_create_menu');

function click5_disable_comments_create_menu() {
  //create submenu in Settings
  add_submenu_page('options-general.php','Disable Comments', 'Disable Comments by click5', 'manage_options','disable-comments-by-click5','click5_disable_comments_settings_page' );
	//call register settings function
	add_action( 'admin_init', 'click5_disable_comments_settings' );
}

function click5_disable_comments_activation_redirect( $plugin ) {
  if( $plugin == plugin_basename( __FILE__ ) ) {
      exit( wp_redirect( admin_url( 'options-general.php?page=disable-comments-by-click5' ) ) );
  }
}
add_action( 'activated_plugin', 'click5_disable_comments_activation_redirect' );

add_filter('plugin_action_links_'.plugin_basename(__FILE__), 'click5_disable_comments_add_plugin_page_settings_link');
function click5_disable_comments_add_plugin_page_settings_link( $links ) {
	$links[] = '<a href="' .
		admin_url( 'options-general.php?page=disable-comments-by-click5' ) .
		'">' . __('Settings') . '</a>';
	return $links;
}

add_filter( 'plugin_row_meta', 'click5_disable_comments_plugin_meta', 10, 2 );
function click5_disable_comments_plugin_meta( $links, $file ) { // add some links to plugin meta row
	if ( strpos( $file, 'disable-comments-by-click5.php' ) !== false ) {
    array_splice( $links, 2, 0, array( '<a href="https://www.click5interactive.com/disable-comments-wordpress-plugin/?utm_source=comments-plugin&utm_medium=plugin-list&utm_campaign=wp-plugins" target="_blank" rel="nofollow">About plugin</a>' ) );
	}
	return $links;
}

// Activation
function click5_disable_comments_activation(){
    do_action( 'click5_disable_comments_default_options' );
}
register_activation_hook( __FILE__, 'click5_disable_comments_activation' );

function click5_disable_comments_forceDefaultSettings() {
  $post_types = click5_disable_comments_get_post_types();
  foreach($post_types as $single_type) {
    $single_type = get_post_type_object($single_type);
    $option_name = 'click5_disable_comments_display_'.$single_type->name;
    update_option($option_name, false);
  }

  update_option("click5_disable_comments_display_globally", true);
  update_option("click5_disable_comments_display_rpc", true);
  update_option("click5_disable_comments_display_api", true);
  
}

add_action( 'click5_disable_comments_default_options', 'click5_disable_comments_forceDefaultSettings' );


function click5_disable_comments_settings() {
  //register our settings

  register_setting( 'click5_disable_comments', 'click5_disable_comments_display_globally' );
  register_setting( 'click5_disable_comments', 'click5_disable_comments_display_rpc' );
  register_setting( 'click5_disable_comments', 'click5_disable_comments_display_api' );
  $option_names1 = array('click5_disable_comments_use_custom_name_globally', 'click5_disable_comments_custom_name_text_globally');
  register_setting('click5_disable_comments', $option_names1[0]);
  register_setting('click5_disable_comments', $option_names1[1]);
  $post_types = click5_disable_comments_get_post_types();

  foreach($post_types as $single_type) {
    $single_type = get_post_type_object($single_type);
    $option_name = 'click5_disable_comments_display_'.$single_type->name;
    $option_names = array('click5_disable_comments_use_custom_name_'.$single_type->name, 'click5_disable_comments_custom_name_text_'.$single_type->name);

    register_setting('click5_disable_comments', $option_name);
    register_setting('click5_disable_comments', $option_names[0]);
    register_setting('click5_disable_comments', $option_names[1]);
  }

  //for authentication purposes
  $current_user = wp_get_current_user();
  register_setting('click5_disable_comments_authentication', 'click5_disable_comments_authentication_token_'.wp_get_current_user()->user_login);
}

function click5_disable_comments_load_plugin_textdomain() {
  load_plugin_textdomain( 'disable-comments-by-click5', FALSE, basename( dirname( __FILE__ ) ) . '/languages/' );
}
add_action( 'plugins_loaded', 'click5_disable_comments_load_plugin_textdomain' );


function click5_disable_comments_settings_page() {
?>
<h1 class="click5_disable_comments_heading"><?php _e('Disable Comments by click5 Settings', 'disable-comments-by-click5'); ?>&nbsp;<span class="version">v<?php echo click5_disable_comments_VERSION; ?></span></h1>
<?php if( isset($_GET["settings-updated"]) ) { ?>
<div id="message" class="updated">
<p><strong><?php _e("Settings saved."); ?></strong></p>
</div>
<?php } ?>
<?php
            if( isset( $_GET[ 'tab' ] ) ) {
                $active_tab = sanitize_key($_GET[ 'tab' ]);
            } else {
              $active_tab = 'html';
            }
?>

<div class="wrap click5_disable_comments_wrapper_content_settings">
<div class="content-left">
<?php
      $verification_token = md5(uniqid(rand(), true));
      $cur_user_id = wp_get_current_user()->user_login;
      update_option('click5_disable_comments_authentication_token_'.$cur_user_id, $verification_token);
?>
<input type="hidden" id="verification_token" value="<?php echo esc_attr($verification_token); ?>" />
<input type="hidden" id="user_identificator" value="<?php echo esc_attr($cur_user_id); ?>" />
<form method="post" action="options.php">
    <?php settings_fields( 'click5_disable_comments' ); ?>
    <?php do_settings_sections( 'click5_disable_comments' ); ?>
    <div id="poststuff">
      <div id="post-body-content">
        <div class="postbox" id="enableSitemap">
          <h3 class="hndle"><span><?php _e('Disable Comments Settings', 'disable-comments-by-click5'); ?></span></h3>
          <div class="inside">
            <p><?php _e('Disable comments globally for all post types (builtin and custom) or select individual post types:', 'disable-comments-by-click5'); ?></p>
            <div class="form-table">
              <div class="click5_disable_comments_post_type_item" style="padding-left:10px">
              <?php $option_name = 'click5_disable_comments_display_globally'?>
              <label for="globally">
              <label for="<?php echo esc_attr($option_name); ?>">
                  <input class="global_disable" type="checkbox" name="<?php echo esc_attr($option_name); ?>" id="<?php echo esc_attr($option_name); ?>" value="1" <?php echo (intval(esc_attr( get_option($option_name) )) == 1 ? 'checked' : ''); ?>>
                  <strong>Globally</strong></label>
                  <p style="padding-left:25px"><span style="color:red">Warning:</span> This will disable comments from every page and post on your website. Use this setting if you do not want to show comments anywhere.</p>
              </div>
              </div>
              <hr style="width:100%;text-align:left;margin-left:0">
              <div class="form-table">
              <div class="click5_disable_comments_post_type_item" style="padding-left:10px">
              <?php
                $post_types = click5_disable_comments_get_post_types();
                foreach($post_types as $single_type) {
                  $single_type = get_post_type_object($single_type);
              ?>
              <?php $option_name = 'click5_disable_comments_display_'.$single_type->name; ?>
              <label for="<?php echo esc_attr($option_name); ?>">
                  <input class="other_disable" type="checkbox" name="<?php echo esc_attr($option_name); ?>" id="<?php echo esc_attr($option_name); ?>" value="1" <?php echo (intval(esc_attr( get_option($option_name) )) == 1 ? 'checked' : ''); ?>>
                  <strong><?php echo esc_attr($single_type->label); ?></strong></label> &nbsp&nbsp&nbsp
               <?php } ?>
               </div>
               </div>
              
          </div>
        </div>
      </div>
    </div>
    <div id="poststuff">
      <div id="post-body-content">
        <div class="postbox" id="enableSitemap">
          <h3 class="hndle"><span><?php _e('Disable External Comments', 'disable-comments-by-click5'); ?></span></h3>
          <div class="inside">
            <p><?php _e('Disable external comments made via XML-RPC or REST API:', 'disable-comments-by-click5'); ?></p>
            
            <div class="form-table">
            
              <div class="click5_disable_comments_post_type_item" style="padding-left:10px">
              <?php $option_name = 'click5_disable_comments_display_rpc'?>
              <label for="rpc">
              <label for="<?php echo esc_attr($option_name); ?>">
                  <input type="checkbox" name="<?php echo esc_attr($option_name); ?>" id="<?php echo esc_attr($option_name); ?>" value="1" <?php echo (intval(esc_attr( get_option($option_name) )) == 1 ? 'checked' : ''); ?>>
                  <strong>Disable XML-RPC Comments</strong></label>
                  
              </div>
              <div class="click5_disable_comments_post_type_item" style="padding-left:10px">
              <?php $option_name = 'click5_disable_comments_display_api'?>
              <label for="api">
              <label for="<?php echo esc_attr($option_name); ?>">
                  <input type="checkbox" name="<?php echo esc_attr($option_name); ?>" id="<?php echo esc_attr($option_name); ?>" value="1" <?php echo (intval(esc_attr( get_option($option_name) )) == 1 ? 'checked' : ''); ?>>
                  <strong>Disable REST API Comments</strong></label>
                  
              </div>
              </div>
          </div>
        </div>
      </div>
    </div>
    <?php 
        submit_button();
    ?>
    
</form>
</div>
<div class="content-right">
      <div id="poststuff">
        <div id="post-body-content">
            <div class="postbox">
              <h3 class="hndle"><span>Plugin Support</span></h3>
              <div class="inside">
                <p>Visit our <a href="http://wordpress.org/support/plugin/disable-comments-by-click5" target="_blank" rel="nofollow">community forum</a> to find answers to common issues, ask questions, submit bug reports, feature suggestions and other tips about our plugin.</p>
                <p>Please consider supporting us by <a href="https://wordpress.org/support/plugin/disable-comments-by-click5/reviews/?filter=5" target="_blank" rel="nofollow">rating this plugin</a>. Thanks!</p>
              </div>
            </div>
            <div class="postbox with-image">
              <a href="https://click5crm.com/?utm_source=comments-plugin&utm_medium=sidebar&utm_campaign=wp-plugins" target="_blank" rel="nofollow">
                <img src="<?php echo plugin_dir_url( __FILE__ ).'assets/banner-300x515-sitemap-plugin.png'; ?>" alt="click5crm">
              </a>
            </div>
            <div class="postbox">
              <h3 class="hndle"><span>Our Other WordPress Plugins</span></h3>
              <div class="inside">
                <p><strong><a href="https://wordpress.org/plugins/sitemap-by-click5/" target="_blank" rel="nofollow">Sitemap by click5</a></strong></p>
                <p>Best plugin to generate and customize HTML & XML sitemaps for your website or blog. Completely FREE!</p>
              </div>
            </div>
        </div>
      </div>
</div>
</div>
    <script>

        document.querySelector('.global_disable').addEventListener('click', function(e) {
            var cheboxList = document.querySelectorAll('.other_disable');
            cheboxList.forEach(function(navElement) {
                navElement.checked = false;
            })
          });


        var cheboxListOther = document.querySelectorAll('.other_disable');
        cheboxListOther.forEach(function (elementOther) {
            elementOther.addEventListener('click', function(e) {
                document.querySelector('.global_disable').checked = false;
            })
        })
        
    </script>
<?php }

function click5_disable_comments_init_admin_scripts() {
  //libraries
  $screen = get_current_screen();
  $version = click5_disable_comments_DEV_MODE ? time() : click5_disable_comments_VERSION;

  if(strpos($screen->base, 'disable-comments-by-click5') !== false) {

    wp_enqueue_style( 'click5_disable_comments_css_admin', plugins_url('/css/admin/index.css', __FILE__), array(), $version);

  }
  
}

add_action('admin_enqueue_scripts','click5_disable_comments_init_admin_scripts');

// uninstall hook

function click5_disable_comments_uninstallFunction() {
  delete_option('click5_disable_comments_display_globally');
  delete_option('click5_disable_comments_display_rpc');
  delete_option('click5_disable_comments_display_api');
  
  $post_types = click5_disable_comments_get_post_types();
  foreach($post_types as $single_type) {
    $single_type = get_post_type_object($single_type);
    delete_option('click5_disable_comments_display_'.$single_type->name);
    delete_option('click5_disable_comments_use_custom_name_'.$single_type->name);
    delete_option('click5_disable_comments_custom_name_text_'.$single_type->name);
    delete_option('click5_disable_comments_seo_post_type_'.$single_type->name);
  }

  $current_user = wp_get_current_user();
  delete_option('click5_disable_comments_authentication_token_'.wp_get_current_user()->user_login);
  
}

register_uninstall_hook(__FILE__, 'click5_disable_comments_uninstallFunction');




















